*by Vidhi Nayyar

#include <Wire.h>
#include <DFRobot_QMC5883.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN 6
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(8, PIN, NEO_GRB + NEO_KHZ800);

DFRobot_QMC5883 compass;

float Angle = 0;
void setup()
{

  Serial.begin(9600);
  
  compass.begin();
  pinMode(12, INPUT);
  pinMode(6, OUTPUT);
  compass.isQMC();
  Serial.println("Initialize QMC5883");
  //compass.setRange(QMC5883_RANGE_2GA);
  compass.setMeasurementMode(QMC5883_CONTINOUS); 
  compass.setDataRate(QMC5883_DATARATE_50HZ);
  //compass.setSamples(QMC5883_SAMPLES_12);
  delay(1000);
  pixels.begin();
  pixels.clear();
}
void loop()
{
  
  // Set declination angle on your location and fix heading
  // You can find your declination on: http://magnetic-declination.com/
  // (+) Positive or (-) for negative
  // For Bytom / Poland declination angle is 4'26E (positive)
  // Formula: (deg + (min / 60.0)) / (180 / PI);
  float declinationAngle = (4.0 + (26.0 / 60.0)) / (180 / PI);
  compass.setDeclinationAngle(declinationAngle);
  Vector mag = compass.readRaw();
  compass.getHeadingDegrees();
  
  Angle = mag.HeadingDegress;
  Serial.println(Angle);
  if(Angle > 0 && Angle < 5)
  {
    pixels.setPixelColor(0, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 40 && Angle < 50)
  {2
    pixels.setPixelColor(1, pixels.Color(0, 150, 0));
    pixels.show();
  }
    else if(Angle > 85 && Angle < 95)
  {
    pixels.setPixelColor(2, pixels.Color(0, 150, 0));
    pixels.show();
  }
    else if(Angle > 130 && Angle <140)
  {
    pixels.setPixelColor(3, pixels.Color(0, 150, 0));
    pixels.show();
  }
    else if(Angle > 175 && Angle < 185)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 175 && Angle < 185)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 220 && Angle < 230)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 265 && Angle < 275)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 310 && Angle < 320)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else if(Angle > 355 && Angle < 0)
  {
    pixels.setPixelColor(4, pixels.Color(0, 150, 0));
    pixels.show();
  }
  else
  {
    for(int i = 0; i<8; i++)
    {
      pixels.setPixelColor(i, pixels.Color(50, 0, 0));
    }
    pixels.show();
  }

}
